//
// Copyright (c) 2012 EMH@NCSU
//
// Fast-feedback Static Analysis Tool. It works on top of FindBugs.
//
// Contributors:
//   Yoonki Song, Brittany Johnson, and Emerson Murphy-Hill
//
package edu.ncsu.csc.emh.fixbugs.core.dom.rewrite;

import org.eclipse.jdt.core.dom.CompilationUnit;
import org.eclipse.jdt.core.dom.rewrite.ImportRewrite;
import org.eclipse.jdt.ui.CodeStyleConfiguration;

/**
 * @author Yoonki Song
 */
public final class RewriteUtil {

	private RewriteUtil() {
		// no instance
	}

	/**
	 * Creates ImportRewrite.
	 * 
	 * @param root
	 *            the AST root.
	 * @param restoreExistingImports
	 *            restore
	 * @return new ImportRewrite.
	 * @see Stub-Utility
	 */
	public static ImportRewrite createImportRewrite(final CompilationUnit root, final boolean restoreExistingImports) {
		ImportRewrite rewrite = CodeStyleConfiguration.createImportRewrite(root, restoreExistingImports);
		if (root.getAST().hasResolvedBindings()) {
			rewrite.setUseContextToFilterImplicitImports(true);
		}

		return rewrite;
	}

}
