/**
 *
 */
package edu.ncsu.csc.emh.fixbugs.core.resolution;

import org.eclipse.jdt.core.dom.ASTNode;

/**
 * @author Yoonki
 */
public interface ISeedNodeSupport {

	/**
	 * Initializes the seed node.
	 * 
	 * @param nodeType
	 *            The type of AST node.
	 */
	void initSeedNode(int nodeType);

	/**
	 * Finds a seed node.
	 * 
	 * @param nodeType
	 *            the node type
	 * @param node
	 *            the AST node
	 * @return the found seed AST node.
	 */
	ASTNode findSeedNode(final int nodeType, final ASTNode node);

	/**
	 * Returns the seed node.
	 * 
	 * @return the seed node.
	 */
	ASTNode getSeedNode();

	/**
	 * Sets the seed node.
	 * 
	 * @param seedNode
	 *            new seed node.
	 */
	void setSeedNode(ASTNode seedNode);
}
