package edu.ncsu.csc.emh.fixbugs.core.resolution;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.Assert;

public final class SearchHint {

	/** */
	private List<String> fHints = null;

	public SearchHint() {
		fHints = new ArrayList<String>();
	}

	public void add(final String hint) {
		Assert.isNotNull(hint);
		if (!fHints.contains(hint)) {
			fHints.add(hint);
		}
	}

	public void remove(final String hint) {
		Assert.isNotNull(hint);
		fHints.remove(hint);
	}

	public final List<String> getHints() {
		return fHints;
	}

	public final void setHints(final List<String> hints) {
		fHints = hints;
	}

	public final boolean matches(final String qualifiedName) {
		for (String hint : fHints) {
			if (qualifiedName.contains(hint)) {
				return true;
			}
		}
		return false;
	}

}
