//
// Copyright (c) 2007-2012 Yoonki Song.
// All rights reserved. This program and the accompanying materials
// are made available under the permission of me.
//
// Contributors:
// Yoonki Song - initial API and implementation
//
package edu.ncsu.csc.emh.fixbugs.core.resolution.correctness.missingArgument;

import org.eclipse.jface.text.Position;
import org.eclipse.jface.text.TypedPosition;

/**
 * <code>VariableDropPosition</code>.
 * 
 * @author Yoonki Song
 * 
 */
public class VariableDropPosition extends TypedPosition {

	/**
	 * Constructor for DropPosition.
	 * 
	 * @param offset
	 *            the offset
	 * @param length
	 *            the length
	 * @param type
	 */
	public VariableDropPosition(final int offset, final int length, final String type) {
		super(offset, length, type);
	}

	public VariableDropPosition(final Position p, final String type) {
		super(p.getOffset(), p.getLength(), type);
	}

	@Override
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("Variable: " + getType());
		buf.append(", Offset: " + getOffset());
		buf.append(", Length: " + getLength());
		return buf.toString();
	}
}
