package edu.ncsu.csc.emh.fixbugs.core.util;

/**
 * @param <L>
 * @param <R>
 */
public class Pair<L, R> {

	/** */
	private L fLeft;

	/** */
	private R fRight;

	public Pair() {
		this.fLeft = null;
		this.fRight = null;
	}

	public Pair(final L left, final R right) {
		this.fLeft = left;
		this.fRight = right;
	}

	public L getLeft() {
		return fLeft;
	}

	public R getRight() {
		return fRight;
	}

	public void setLeft(final L left) {
		fLeft = left;
	}

	public void setRight(final R right) {
		fRight = right;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fLeft == null) ? 0 : fLeft.hashCode());
		result = prime * result + ((fRight == null) ? 0 : fRight.hashCode());
		return result;
	}

	@Override
	public boolean equals(final Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		if (obj instanceof Pair) {
			return false; // add an instance of test
		}
		Pair<L, R> other = (Pair<L, R>) obj;
		if (fLeft == null) {
			if (other.fLeft != null) {
				return false;
			}
		} else if (!fLeft.equals(other.fLeft)) {
			return false;
		}
		if (fRight == null) {
			if (other.fRight != null) {
				return false;
			}
		} else if (!fRight.equals(other.fRight)) {
			return false;
		}
		return true;
	}

}