//
// Copyright (c) 2012 EMH@NCSU
//
// Fast-feedback Static Analysis Tool. It works on top of FindBugs.
//
// Contributors:
//   Yoonki Song, Brittany Johnson, and Emerson Murphy-Hill
//
package edu.ncsu.csc.emh.fixbugs.ui;

import org.eclipse.jface.resource.ImageDescriptor;

import edu.ncsu.csc.emh.fixbugs.Activator;

/**
 * @author Yoonki Song
 */
public final class Images {

	private Images() {
		// no instantiation.
	}

	/** */
	public static final String BASE_PATH = "/icons/full";

	/** */
	public static final String TOOL = "etool16";

	/** */
	public static final String VIEW = "eview16";

	/** */
	public static final ImageDescriptor BUG = create(TOOL, "bug.png"); //$NON-NLS-1$

	/** */
	public static final ImageDescriptor FIX = create(TOOL, "fix.gif"); //$NON-NLS-1$

	/** */
	public static final ImageDescriptor CLOSE = create(VIEW, "close.gif"); //$NON-NLS-1$

	/** */
	public static final ImageDescriptor CLOSE_ACTIVE = create(VIEW, "close-active.gif"); //$NON-NLS-1$

	/** */
	public static final ImageDescriptor VIEW_MENU = create(VIEW, "view_menu.gif"); //$NON-NLS-1$

	/**
	 * Creates an ImageDescriptor.
	 * 
	 * @param prefix
	 *            the prefix
	 * @param name
	 *            the icon name
	 * @return new ImageDescriptor
	 */
	public static ImageDescriptor create(final String prefix, final String name) {
		StringBuffer buffer = new StringBuffer(BASE_PATH);
		buffer.append('/').append(prefix).append('/').append(name);
		// System.out.println("ID: " + buffer.toString());
		// System.out.println("ID: " + id.toString());
		return Activator.getImageDescriptor(buffer.toString());
	}
}
