//
// Copyright (c) 2012 EMH@NCSU
//
// Fast-feedback Static Analysis Tool. It works on top of FindBugs.
//
// Contributors:
//   Yoonki Song, Brittany Johnson, and Emerson Murphy-Hill
//
package edu.ncsu.csc.emh.fixbugs.ui;

import java.text.MessageFormat;
import java.util.ResourceBundle;

import org.eclipse.osgi.util.NLS;

/**
 * @author Yoonki
 */
public final class Messages extends NLS {

	/** */
	private static final String BUNDLE_NAME = "edu.ncsu.csc.emh.fixbugs.ui.Messages"; //$NON-NLS-1$

	private static ResourceBundle fgBundleForConstructedKeys = ResourceBundle.getBundle(BUNDLE_NAME);

	/**
	 * Returns the message bundle which contains constructed keys.
	 * 
	 * @since 3.1
	 * @return the message bundle
	 */
	public static ResourceBundle getBundleForConstructedKeys() {
		return fgBundleForConstructedKeys;
	}

	public static ResourceBundle getResourceBundle() {
		return fgBundleForConstructedKeys;
	}

	/** */
	public static String markerResolution;

	/** */
	public static String stringBufferConcatenationResolution;

	/** */
	public static String catchExceptionResolution;

	/** */
	public static String uniCatchExceptionResolution;

	/** */
	public static String multiCatchExceptionResolution;

	/** */
	public static String openStreamExceptionPathResolution;

	/** */
	public static String missingArgumentResolution;

	//

	/** */
	public static String linkedModeErrorSavingEditor;

	//

	/** */
	public static String popupClose;

	/** */
	public static String popupDelayJobName;

	/** */
	public static String popupMenu;

	//

	/** */
	public static String popupMessage;

	/** */
	public static String popupPreferences;

	/** */
	public static String popupSnapTo;

	/** */
	public static String popupSnapTopLeft;

	/** */
	public static String popupSnapTopRight;

	/** */
	public static String popupSnapBottomLeft;

	/** */
	public static String popupSnapBottomRight;

	/** */
	public static String popupSnapOverLeft;

	/** */
	public static String popupSnapOverRight;

	/** */
	public static String popupSnapUnderLeft;

	/** */
	public static String popupSnapUnderRight;

	/** */
	public static String originalOption;

	/** */
	public static String defaultSuggestion;

	/** */
	public static String myLastChange;

	//

	/** */
	public static String stringBufferConcatenationMessage;

	/** */
	public static String useStringBuilder;

	/** */
	public static String useStringBuffer;

	/** */
	public static String addedAnnotation;

	/** */
	public static String modifiedAnnotation;

	/** */
	public static String deletedAnnotation;

	/** */
	public static String relatedAnnotation;

	//

	/** */
	public static String openStreamExceptionPathMessage;

	/** */
	public static String splitAndMoveCloseToFinallyBlock;

	/** */
	public static String useTryWithResources;

	//

	/** */
	public static String missingArgumentMessage;

	/** */
	public static String missingArgumentAnnotation;

	/** */
	public static String presentedVariableAnnotation;

	/** */
	public static String suggestibleVariableAnnotation;

	//

	/** */
	public static String catchExceptionMessage;

	/** */
	public static String methodThrowsExceptions;

	/** */
	public static String exceptionMayThrownByMethod;

	/**
	 * Gets a string from the resource bundle and formats it with the argument
	 * 
	 * @param key
	 *            the string used to get the bundle value, must not be null
	 * @param arg
	 *            the single argument
	 * @return the formatted string
	 */
	public static String format(String key, Object arg) {
		return MessageFormat.format(key, new Object[] { arg });
	}

	/**
	 * Gets a string from the resource bundle and formats it with arguments
	 * 
	 * @param key
	 *            the string used to get the bundle value, must not be null
	 * @param args
	 *            the arguments
	 * @return the formatted string
	 */
	public static String format(String key, Object[] args) {
		return MessageFormat.format(key, args);
	}

	static {
		NLS.initializeMessages(BUNDLE_NAME, Messages.class);
	}

	private Messages() {
		// No instance
	}

}
