//
// Copyright (c) 2012 EMH@NCSU
//
// Fast-feedback Static Analysis Tool. It works on top of FindBugs.
//
// Contributors:
//   Yoonki Song, Brittany Johnson, and Emerson Murphy-Hill
//
package edu.ncsu.csc.emh.fixbugs.ui.actions;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.eclipse.core.resources.IMarker;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor;
import org.eclipse.jdt.ui.JavaUI;
import org.eclipse.jface.text.ITextSelection;

import edu.ncsu.csc.emh.fixbugs.core.resolution.FixBugsContext;
import edu.ncsu.csc.emh.fixbugs.core.resolution.SearchHint;
import edu.ncsu.csc.emh.fixbugs.core.resolution.badPractice.openStreamExceptionPath.OpenStreamExceptionPathAssistant;
import edu.ncsu.csc.emh.fixbugs.ui.resolutions.badPractice.openStreamExceptionPath.OpenStreamExceptionPathMode;

/**
 * 
 * @author Yoonki
 */
public final class OpenStreamExceptionPathAction extends FixBugsAction {
	/** For logging purpose only. */
	private static Logger fLogger = Logger.getLogger(OpenStreamExceptionPathAction.class.getName());
	static {
		fLogger.setLevel(Level.WARNING);
	}

	public OpenStreamExceptionPathAction(final IMarker marker) {
		super(marker);
	}

	@Override
	public void run() {
		fLogger.info("OpenStreamExceptionPathAction#run()");
		if (!ActionUtil.isEditable(getEditor())) {
			return;
		}

		ICompilationUnit cu = JavaUI.getWorkingCopyManager().getWorkingCopy(getEditor().getEditorInput());
		if (cu == null) {
			return;
		}

		ITextSelection textSelection = getTextSelection();
		FixBugsContext context = new FixBugsContext(cu, textSelection.getOffset(), textSelection.getLength());
		SearchHint hint = new SearchHint();
		// TODO We should use hierarchy instead of post-fixes of sub classes!
		hint.add("Stream");
		hint.add("Reader");
		hint.add("JarFile");
		OpenStreamExceptionPathAssistant assistant = new OpenStreamExceptionPathAssistant(context, hint);

		if (getEditor() instanceof CompilationUnitEditor) {
			new OpenStreamExceptionPathMode((CompilationUnitEditor) getEditor(), assistant).start(true);
		}
	}
}
