package edu.ncsu.csc.emh.fixbugs.ui.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.Command;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.State;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.commands.ICommandService;
import org.eclipse.ui.handlers.HandlerUtil;

import edu.ncsu.csc.emh.fixbugs.ui.resolutions.FixBugsLinkedMode;

/**
 * Our sample handler extends AbstractHandler, an IHandler base class.
 * 
 * @see org.eclipse.core.commands.IHandler
 * @see org.eclipse.core.commands.AbstractHandler
 */
public class TogglePopupHandler extends AbstractHandler {

	public static final String COMMAND_ID = "edu.ncsu.csc.emh.fixbugs.ui.commands.togglePopupId";

	public static final String STATE_ID = "org.eclipse.ui.commands.toggleState";

	/**
	 * The constructor.
	 */
	public TogglePopupHandler() {
	}

	/**
	 * the command has been executed, so extract the needed information from the
	 * application context.
	 */
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		// IWorkbenchWindow window =
		// HandlerUtil.getActiveWorkbenchWindowChecked(event);
		Command command = event.getCommand();
		boolean oldValue = HandlerUtil.toggleCommandState(command);
		// use the old value and perform the operation
		if (oldValue) {
			System.out.println("hide the mode.");
			FixBugsLinkedMode mode = FixBugsLinkedMode.getActiveMode();
			if (mode != null) {
				mode.hide();
			}
		} else {
			System.out.println("show the mode.");
			FixBugsLinkedMode mode = FixBugsLinkedMode.getActiveMode();
			if (mode != null) {
				mode.show();
			}
		}
		return null;
	}

	public static void showOrHide(Boolean value) {
		System.out.println("#showOrHide");
		ICommandService service = (ICommandService) PlatformUI.getWorkbench().getService(ICommandService.class);
		Command command = service.getCommand(COMMAND_ID);
		State state = command.getState(STATE_ID);
		state.setValue(value);
	}
}
