/**
 * 
 */
package edu.ncsu.csc.emh.fixbugs.ui.services;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.ui.AbstractSourceProvider;
import org.eclipse.ui.ISources;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.services.ISourceProviderService;

/**
 * @author Yoonki
 * 
 */
public class CommandState extends AbstractSourceProvider {
	public final static String MY_STATE = "edu.ncsu.csc.emh.fixbugs.ui.services.active";
	public final static String ENABLED = "ENABLED";
	public final static String DISABLED = "DISABLED";
	private boolean enabled = false;

	/**
	 * 
	 */
	public CommandState() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.ISourceProvider#dispose()
	 */
	@Override
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.ISourceProvider#getCurrentState()
	 */
	@Override
	public Map getCurrentState() {
		Map map = new HashMap(1);
		String value = enabled ? ENABLED : DISABLED;
		map.put(MY_STATE, value);
		return map;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.ISourceProvider#getProvidedSourceNames()
	 */
	@Override
	public String[] getProvidedSourceNames() {
		return new String[] { MY_STATE };
	}

	public void toggleEnabled() {
		enabled = !enabled;
		String value = enabled ? ENABLED : DISABLED;
		fireSourceChanged(ISources.WORKBENCH, MY_STATE, value);
	}

	public static void toggle() {
		// Get the source provider service
		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
		ISourceProviderService sourceProviderService = (ISourceProviderService) window.getService(ISourceProviderService.class);
		// Now get my service
		CommandState commandStateService = (CommandState) sourceProviderService.getSourceProvider(CommandState.MY_STATE);
		commandStateService.toggleEnabled();
	}

}
