//
// Copyright (c) 2012 EMH@NCSU
//
// Fast-feedback Static Analysis Tool. It works on top of FindBugs.
//
// Contributors:
//   Yoonki Song, Brittany Johnson, and Emerson Murphy-Hill
//
package edu.ncsu.csc.emh.fixbugs.resolutions.performance.stringBufferConcatenation;

import org.eclipse.core.resources.IMarker;

import edu.ncsu.csc.emh.fixbugs.ui.Messages;
import edu.ncsu.csc.emh.fixbugs.ui.actions.StringBufferConcatenationAction;
import edu.ncsu.csc.emh.fixbugs.ui.resolutions.FixBugsMarkerResolution;

/**
 * @see edu.umd.cs.findbugs.detect.StringConcatenation
 * @author Yoonki
 */
public final class StringBufferConcatenationResolution extends FixBugsMarkerResolution {

	@Override
	public String getLabel() {
		return Messages.stringBufferConcatenationResolution;
	}

	@Override
	public void run(final IMarker marker) {
		StringBufferConcatenationAction action = new StringBufferConcatenationAction(marker);
		action.run();
	}
}
